import org.junit.jupiter.api.AfterAll;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Test;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.chrome.ChromeDriver;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertTrue;

/***
 * Unmesh Gundecha „Selenium i testowanie aplikacji: Receptury”, Wydanie II, Helion, Gliwice 2017
 * testelka.pl [ostatnia wizyta: 30.01.2023]
 */

class ShopTest {
    private static WebDriver driver;

    @BeforeAll
    static void setDriver() {
        System.setProperty("webdriver.chrome.driver","/home/arek/selenium/chromium/chromedriver");
        driver = new ChromeDriver();
        driver.manage().window().maximize();
    }

    @Test
    void getHomePage() {
        ShopHomePage homePage = new ShopHomePage(driver);
        homePage.goToHomePage();
        assertEquals("Generic Shop – Just another web shop", homePage.getTitle());
    }

    @Test
    void addLittleBlackTopToCart() {
        ShopHomePage homePage = new ShopHomePage(driver);
        homePage.goToHomePage();
        assertTrue(homePage.pressProductButton(String.valueOf(Products.LITTLE_BLACK_TOP)).isDisplayed());
    }

    @Test
    void addLittleBlackShirtToTopToCart() {
        ShopHomePage homePage = new ShopHomePage(driver);
        homePage.goToHomePage();
        assertTrue(homePage.pressProductButton(String.valueOf(Products.LITTLE_BlACK_SHIRT)).isDisplayed());
    }

    @Test
    void verifyCartContent() {
        ShopHomePage homePage = new ShopHomePage(driver);
        homePage.goToHomePage();
        homePage.pressProductButton(Products.LITTLE_BLACK_TOP.toString());
        homePage.pressProductButton(Products.LITTLE_BlACK_SHIRT.toString());
        homePage.pressCartButton();
        CartPage cartPage = new CartPage(driver);
        assertEquals("72.00 zł", cartPage.getTotalPrice());
    }

    @AfterAll
    static void tearDown() {
        driver.close();
        driver.quit();
    }

}